# -*- coding: utf-8 -*-
#
# File: Plone2Postgresql/Extensions/Install.py
#
# Copyright (c) 2007 Redomino
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

"""
$Id$
"""

__author__ = """Fabrizio Reale <fabrizio.reale@redomino.com>"""
__docformat__ = 'plaintext'
__licence__ = 'GPL'


from StringIO import StringIO
from Products.Plone2Postgresql.config import *
from Products.Archetypes.Extensions.utils import install_subskin

def install_actions(self,out):
  print >> out, "Install action."

  atool=self.portal_actions

  existing_actions=[a.id for a in atool._cloneActions()]
  if 'create_postgresql_view' not in existing_actions:
    atool.addAction(id='create_postgresql_view',
                    name='Export to Postgresql',
                    action='string:$object_url/@@create_postgresql_view',
                    condition='python:object.getPortalTypeName() == "Topic"',
                    permission='Manage Portal',
                    category='object',
                    visible=1)

  print >>out, "Action was sucessfully installed"
  install_subskin(self, out, GLOBALS)

def install(self):
    """
    Install Plone2Postgresql
    """
    out = StringIO()
   
    #install action
    install_actions(self,out)
  
    print "installed Plone2Postgresql"
    return out.getvalue()

def uninstall_actions(self,out):
    atool=self.portal_actions

    existing_actions=[a.id for a in atool._cloneActions()]
    if 'create_postgresql_view' in existing_actions:
        atool.deleteActions([existing_actions.index('create_postgresql_view')])

    print >>out, "Action was sucessfully uninstalled"


def uninstall(self):
    out = StringIO()

    uninstall_actions(self,out)   
 
    return out.getvalue()
